<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="60%" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="科目编码" prop="sn">
                    <el-input v-model="formData.sn" clearable placeholder="请输入科目编码" />
                </el-form-item>
                <el-form-item label="一级科目" prop="subject1">
                    <el-input v-model="formData.subject1" clearable placeholder="请输入一级科目" />
                </el-form-item>
                <el-form-item label="二级科目" prop="subject2">
                    <el-input v-model="formData.subject2" clearable placeholder="请输入二级科目" />
                </el-form-item>

            </el-form>
        </popup>


    </div>
</template>

<script lang="ts" setup name="customFollowEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apisubjectAdd, apisubjectEdit, apisubjectDetail } from '@/api/cost_subject'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'

defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')

// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑费用科目' : '新增费用科目'
})

// 表单数据
const formData = reactive({
    id: '',
    sn: '',
    subject1: '',
    subject2: '',

})


// 表单验证
const formRules = reactive<any>({

})
// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }

}

const getDetail = async (row: Record<string, any>) => {
    const data = await apisubjectDetail({
        id: row.id
    })
    setFormData(data)
}



// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apisubjectEdit(data)
        : await apisubjectAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
